package jtaDiscRack.presentation.delements;

import jtaDiscRack.presentation.dpanels.*;

/**
 * Represents a simple element which have a panel for it's editing.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class DSimpleElement {

   protected String name;
   protected Object value;

   protected boolean isRequired=false;
   protected boolean isReadOnly=false;

   private boolean isDCheckPanel=false;
   private boolean isPassword=false;

   public DSimpleElement (String name) {
      this (name,false);
   }

   public DSimpleElement (String name,boolean isDCheckPanel) {
      this(name,isDCheckPanel,false);
   }

   public DSimpleElement (String name,boolean isDCheckPanel,boolean isPassword) {
      this.name=name;
      this.isDCheckPanel=isDCheckPanel;
      this.isPassword=isPassword;
      value=new String();
   }

   public void setReadOnly (boolean ro) {
      isReadOnly=ro;
   }

   public boolean isReadOnly () {
      return isReadOnly;
   }

   public void setRequired (boolean r) {
      isRequired=r;
   }

   public boolean isRequired () {
      return isRequired;
   }

   public boolean isEmpty () {
      return !(value!=null && value.toString().trim().length()>0);
   }

   public boolean isValid () {
      return true;
   }

   public boolean setDODSElements (DPanel p) {
      return true;
   }

   public DPanel getPanel () {
      if (!isDCheckPanel) {
         return new DTextPanel(this,isPassword);
      } else {
         return new DCheckPanel(this);
      }
   }

   public void setValue(Object v) {
      if (v!=null) {
         value=v;
      } else {
         value="";
      }
   }

   public Object toValue() {
      return value;
   }

   public String toName () {
      return name;
   }

   public String toString () {
      if (value!=null) {
         return value.toString().trim();
      }
      else {
         return name;
      }
   }

}
